program CaBomba;
{ Vers.0.900: Intuition-Update, so da Maustaste 1 und 2 abgefragt werden }
{   30.11.96: kann - Spielroutinen: Feld whlen, Bombe markieren, Markie- }
{             rungen aufheben, leere Felder auswerten, markierte Bomben   }
{             auswerten, Anzeigen, [neu], [alt], [quit], Ende-Routine 1   }
{   01.12.96: Helpscreen, Hilfe bei "Bombensuche", Ende-Routine 2         }
{   02.12.96: Timer und Hiscore-2-Routinen                                }
{   04.12.96: Vorzeitiger Ausstieg aus Ende-Routine                       }
{   13.12.96: Vers. 1.000: Level-Handling,9 Levels                        }

uses crt,dos,graph,drivers,BGIDriv,BGIFont,intuit,hitime;

const titel1=' CaBomba'; titel2='Vers.1.000 by UJA'; titel3='TP6';
      levelfile='CaBomba.L'; imafile='CaBomba.ima';
      hscfil='CaBomba.H';
      xmax=38; ymax=25; dx=16; dy=16; ofx=0; ofy=16; gmax=8;
      pal:array[0..15,0..2] of word=
      (( 0, 0, 0),(13,15,24),( 0,42, 0),( 0,36,42),
       (42, 0, 0),(42, 0,42),(51,26, 0),(28,39,49),
       (21,21,21),(21,21,63),(27,63,17),(21,63,63),
       (63,24,24),(63,21,63),(63,58, 0),(63,63,63));

type feld=array[0..succ(xmax),0..succ(ymax)] of integer;
     { 0-8: Nachbarschaft, 9: Cabomba, +10: offen, +20: markiert, -1:weg! }


var ok,ende,hopps,hflag                        :boolean;
    ch                                         :char;
    temp,levelname,hscfile                     :string;
    code1,code2,b1,b2,g,mx,my,key,x,y,level    :integer;
    f                                          :feld;
    ho,mi,se,tic,err                           :word;

    igad                                       :array[1..gmax] of Gadget;
    itext1,itext2                              :array[1..gmax] of Intuitext;
    ibord1,ibord2,ibord3,ibord4                :Border;
    xy1,xy2,xy3,xy4                            :Koords;
    ima                                        :array[0..15] of Image;
    bomba,bombmask                             :Image;
    sinfo                                      :StrInfo;
    hsc                                        :HighScore;
    punkte                                     :LongInt;
{ ------------------------------------------------------------------------- }
procedure getimages;
var i:integer;
    anz:word;
    fh:file;
begin
   assign(fh,imafile);
   reset(fh,1);
   BlockRead(fh,ima[0],sizeof(image),anz);
   with ima[0] do begin
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      BlockRead(fh,p_data^,anz,anz);
      putimage(0,0,ima[0].p_data^,normalput);
      FreeMem(p_data,anz);
   end;
   close(fh);

   for i:=0 to 13 do with ima[i] do begin
      width:=dx;
      height:=dy;
      p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(i*dx,0,pred(succ(i)*dx),pred(dy),p_data^);
   end;
   with bombmask do begin
      width:=176;
      height:=192;
      p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(0,dy,pred(width),dy+pred(height),p_data^);
   end;
   with bomba do begin
      width:=176;
      height:=192;
      p_nextimage:=nil;
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(width,dy,pred(2*width),pred(dy+height),p_data^);
   end;
end;

procedure setcolors;
var i:integer;
begin
for i:=0 to 15 do begin
   setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2]);
   setpalette(i,i);
end;
end;

procedure darken;
var i:integer;
begin
for i:=0 to 15 do setpalette(i,i);
end;

{ ------------------------------------------------------------------------ }
procedure intuikram;
var i,j,k:integer;
begin
   itext1[1].itext:='Hilfe';
   itext1[2].itext:=' Alt ';
   itext1[3].itext:=' Neu ';
   itext1[4].itext:=' Ende';
   itext1[5].itext:='Level:';
   for i:=1 to 5 do begin
      with itext1[i] do begin
         x:=10;
         y:=4;
         fpen:=7;
         bpen:=9;
         drmode:=jam1;
         p_nexttext:=addr(itext2[i]);
      end;
      itext2[i]:=itext1[i];
      with itext2[i] do begin
         x:=itext1[i].x-2;
         fpen:=0;
         p_nexttext:=nil;
      end;
   end;

   xy1[0]:=0; xy1[1]:=14; xy1[2]:=0;  xy1[3]:=0;  xy1[4]:=63; xy1[5]:=0;
   xy2[0]:=0; xy2[1]:=15; xy2[2]:=63; xy2[3]:=15; xy2[4]:=63; xy2[5]:=1;
   with ibord1 do begin
      x:=0;
      y:=0;
      fpen:=15;
      bpen:=9;
      drmode:=jam1;
      ecken:=3;
      p_ecken:=addr(xy1);
      p_nextborder:=addr(ibord2);
   end;
   with ibord2 do begin
      x:=0;
      y:=0;
      fpen:=0;
      bpen:=9;
      drmode:=jam1;
      ecken:=3;
      p_ecken:=addr(xy2);
      p_nextborder:=nil;
   end;

   xy3[0]:=0; xy3[1]:=14; xy3[2]:=0;  xy3[3]:=0;  xy3[4]:=103; xy3[5]:=0;
   xy4[0]:=0; xy4[1]:=15; xy4[2]:=103; xy4[3]:=15; xy4[4]:=103; xy4[5]:=1;
   with ibord3 do begin
      x:=0;
      y:=0;
      fpen:=15;
      bpen:=9;
      drmode:=jam1;
      ecken:=3;
      p_ecken:=addr(xy3);
      p_nextborder:=addr(ibord4);
   end;
   with ibord4 do begin
      x:=0;
      y:=0;
      fpen:=0;
      bpen:=9;
      drmode:=jam1;
      ecken:=3;
      p_ecken:=addr(xy4);
      p_nextborder:=nil;
   end;

   with sinfo do begin
      x:=64;
      y:=4;
      maxlen:=4;
      fpen:=15;
      bpen:=1;
      buff:='000';
      ubuff:='';
   end;


   for i:=1 to 4 do with igad[i] do begin
      id:=i;
      x:=304+i*64;                    y:=456;
      width:=64;                      height:=16;
      bpen:=9;                        hibpen:=bpen;
      p_loborder:=addr(ibord1);       p_hiborder:=p_loborder;
      p_loimage:=nil;                 p_hiimage:=p_loimage;
      p_lointuitext:=addr(itext1[i]); p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;                   active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=addr(igad[succ(i)]);
   end;
   i:=5;
   with igad[i] do begin
      id:=i;
      x:=368;                         y:=440;
      width:=104;                      height:=16;
      bpen:=9;                        hibpen:=bpen;
      p_loborder:=addr(ibord3);       p_hiborder:=p_loborder;
      p_loimage:=nil;                 p_hiimage:=p_loimage;
      p_lointuitext:=addr(itext1[i]); p_hiintuitext:=p_lointuitext;
      gadgettyp:=strgadget;
      onoff:=false;                   active:=true;
      p_specialinfo:=addr(sinfo);
      p_nextgadget:=addr(igad[succ(i)]);
   end;
   i:=6;
   with igad[i] do begin
      id:=i;
      x:=ofx+dx;                   y:=ofy+dy;
      width:=xmax*dx;              height:=ymax*dy;
      bpen:=-1;                    hibpen:=bpen;
      p_loborder:=nil;             p_hiborder:=p_loborder;
      p_loimage:=nil;              p_hiimage:=p_loimage;
      p_lointuitext:=nil;          p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;                active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=nil;
   end;
end;

{ ------------------------------------------------------------------------ }
function updatzeit(ho,mo,so,po:word):integer;
var h,m,s,p:word;
    temp   :string;
    sec    :integer;
begin
gettime(h,m,s,p);
p:=p-po; if p<0 then begin dec(s); p:=p+100; end;
s:=s-so; if s<0 then begin dec(m); s:=s+60; end;
m:=m-mo; if m<0 then begin dec(h); m:=m+60; end;
h:=h-ho;
sec:=60*(h*60+m)+s;
updatzeit:=sec;
end;




procedure showelement(x,y,typ:integer);
var i,j,k:integer;
begin
   case typ of
       -1: begin
              k:=0;
              for i:=pred(x) to succ(x) do for j:=pred(y) to succ(y) do
              if f[i,j]<>-1 then inc(k);
              if k>0 then begin
              rectfill(x*dx+ofx,y*dy+ofy,pred(x*dx+dx+ofx),pred(y*dy+ofy+dy),7);
              putimage(x*dx+ofx,y*dy+ofy,ima[10].p_data^,andput);
              end else
              rectfill(x*dx+ofx,y*dy+ofy,pred(x*dx+dx+ofx),pred(y*dy+ofy+dy),1);
           end;
    0.. 9: putimage(x*dx+ofx,y*dy+ofy,ima[10].p_data^,normalput);
   10..19: putimage(x*dx+ofx,y*dy+ofy,ima[typ-10].p_data^,normalput);
   20..29: putimage(x*dx+ofx,y*dy+ofy,ima[11].p_data^,normalput);
   30..39: putimage(x*dx+ofx,y*dy+ofy,ima[13].p_data^,normalput);
       40: putimage(x*dx+ofx,y*dy+ofy,ima[12].p_data^,normalput);
   end;
end;


procedure showbombas(bomba:integer);
var temp:string;
begin
   str(bomba:3,temp);
   temp:='CaBombas:'+temp;
   rectfill(192,448,287,455,1);
   setcolor( 4); outtextxy(193,448,temp);
   setcolor(12); outtextxy(192,448,temp);
end;

procedure showlevel(l:integer; levelname:string);
var temp:string;
begin
   str(l:3,temp);
   temp:='Level'+temp+': '+levelname;
   rectfill(8,456,287,471,1);
   setcolor( 6); outtextxy(9,460,temp);
   setcolor(14); outtextxy(8,460,temp);
end;

procedure mainscreen(level:integer; levelname:string; b1,b2:integer);
var temp:string;
    i,j,k:integer;
begin
   rectfill(0,0,639,479,1);
   rectfill(4,4,635,19,9);
   setcolor(15); line(4,4,635,4);   line(4,4,4,18);
   setcolor(0);  line(4,19,635,19); line(635,5,635,19);
   for i:=1 to 5 do begin
      setcolor(15);
      outtextxy(succ(i*80-72),8,titel1);
      case i of
      1: setcolor(2);
      2: setcolor(4);
      3: setcolor(0);
      4: setcolor(5);
      5: setcolor(6);
      end;
      outtextxy(i*80-72,8,titel1);
   end;
   setcolor(15); outtextxy(421,8,titel2); outtextxy(601,8,titel3);
   setcolor(0);  outtextxy(420,8,titel2); outtextxy(600,8,titel3);
   for j:=1 to ymax do for i:=1 to xmax do showelement(i,j,f[i,j]);
   str(level:3,sinfo.buff);
   RefreshGadgets(addr(igad[1]));
   showbombas(b1-b2);
   showlevel(level,levelname);
   hflag:=false;
   if hopps then begin
      setcolor(15);
      outtextxy(256,400,'G a m e   o v e r');
   end;
end;


procedure initgame(var level,bombas,b2:integer; var levelname,hscfile:string;
                   var punkte:longint; var f:feld; var hopps,ende:boolean);
const x0=30; y0=16; b0=99; ox0=4; oy0=4; l0=0; lnam0='Intern';
var i,j,k,l:integer;
   t,temp:string;
   fh:text;
begin
for i:=0 to succ(xmax) do for j:=0 to succ(ymax) do f[i,j]:=-1;

str(level:2,t);
if t[1]=' ' then t[1]:='0';
temp:=levelfile+t;

assign(fh,temp);
{$i-}
reset(fh);
if ioresult<>0 then begin
   { built-in Level }
   for i:=1 to x0 do for j:=1 to y0 do f[i+ox0,j+oy0]:=0;
   bombas:=b0;
   level:=l0;
   levelname:=lnam0;
   hscfile:=hscfil+'00';
end else begin
   readln(fh,levelname);
   readln(fh,bombas);
   for j:=1 to ymax do begin
      readln(fh,temp);
      for i:=1 to length(temp) do if temp[i]='#' then f[i,j]:=0;
   end;
   hscfile:=hscfil+t;
end;
close(fh);
{$i+}

loadhighscore(hscfile,hsc);
hopps:=false;
ende:=false;
b2:=0;
k:=0;
randomize;
while k<bombas do begin
   i:=succ(random(10000) mod xmax);
   j:=succ(random(10000) mod ymax);
   if f[i,j]=0 then begin
      inc(k);
      f[i,j]:=9;
   end;
end;
for i:=1 to xmax do for j:=1 to ymax do if f[i,j]=9 then begin
   for k:=pred(i) to succ(i) do for l:=pred(j) to succ(j) do
   if (f[k,l]>-1) and (f[k,l]<9) then inc(f[k,l]);
end;
gettime(ho,mi,se,tic);
punkte:=0;
end;

procedure resetgame(var bombas:integer; var f:feld);
var x,y:integer;
begin
   bombas:=0;
   hopps:=false;
   for x:=1 to xmax do for y:=1 to ymax do
   if f[x,y]>-1 then f[x,y]:=f[x,y] mod 10;
   gettime(ho,mi,se,tic);
   punkte:=0;
end;


procedure game(x,y,key:integer; var b2:integer; var f:feld;
               var hopps:boolean);
var i,j,k,l,m:integer;

{ --- }
   procedure cleansweep;  { angeklicktes Feld ist leer }
   begin
      dec(i);
      dec(j);
      if (f[i,j]<10) and (f[i,j]>-1) then begin
         f[i,j]:=f[i,j]+10;
         showelement(i,j,f[i,j]);
         if f[i,j]=10 then cleansweep;
      end;
      inc(i);
      if (f[i,j]<10) and (f[i,j]>-1) then begin
         f[i,j]:=f[i,j]+10;
         showelement(i,j,f[i,j]);
         if f[i,j]=10 then cleansweep;
      end;
      inc(i);
      if (f[i,j]<10) and (f[i,j]>-1) then begin
         f[i,j]:=f[i,j]+10;
         showelement(i,j,f[i,j]);
         if f[i,j]=10 then cleansweep;
      end;
      inc(j);
      if (f[i,j]<10) and (f[i,j]>-1) then begin
         f[i,j]:=f[i,j]+10;
         showelement(i,j,f[i,j]);
         if f[i,j]=10 then cleansweep;
      end;
      inc(j);
      if (f[i,j]<10) and (f[i,j]>-1) then begin
         f[i,j]:=f[i,j]+10;
         showelement(i,j,f[i,j]);
         if f[i,j]=10 then cleansweep;
      end;
      dec(i);
      if (f[i,j]<10) and (f[i,j]>-1) then begin
         f[i,j]:=f[i,j]+10;
         showelement(i,j,f[i,j]);
         if f[i,j]=10 then cleansweep;
      end;
      dec(i);
      if (f[i,j]<10) and (f[i,j]>-1) then begin
         f[i,j]:=f[i,j]+10;
         showelement(i,j,f[i,j]);
         if f[i,j]=10 then cleansweep;
      end;
      dec(j);
      if (f[i,j]<10) and (f[i,j]>-1) then begin
         f[i,j]:=f[i,j]+10;
         showelement(i,j,f[i,j]);
         if f[i,j]=10 then cleansweep;
      end;
      inc(i);
   end;

{ --- }


begin
   if f[x,y]>-1 then begin
      if f[x,y]<10 then begin  { geschlossenes Feld }
         case key of
           1: begin { ffnen }
                 f[x,y]:=f[x,y]+10;
                 showelement(x,y,f[x,y]);
                 hopps:=hopps or (f[x,y]=19);
                 if f[x,y]=10 then begin
                    i:=x;
                    j:=y;
                    cleansweep; { keine parms wg. Rekursion }
                 end;
              end;
         2,3: begin { mit Bombe markieren }
                 f[x,y]:=f[x,y]+20;
                 inc(b2);
                 showelement(x,y,f[x,y]);
                 showbombas(b1-b2);
              end;
         end;
      end else if f[x,y]<20 then begin  { offenes Feld }
         case key of
         1,2: begin  { Markierte Bomben mit Zahl vergleichen: }
                 k:=0;
                 l:=f[x,y] mod 10;
                 for i:=pred(x) to succ(x) do for j:=pred(y) to succ(y) do
                 if (x<>i) or (y<>j) then if (f[i,j] div 10)=2 then inc(k);
                 if k=l then begin { markierte Bomben = tatschliche Bombem }
                    for i:=pred(x) to succ(x) do for j:=pred(y) to succ(y) do
                    if (x<>i) or (y<>j) then begin { Umgebung ffnen }
                       if (f[i,j]>-1) and (f[i,j]<10) then begin
                          f[i,j]:=f[i,j]+10;
                          showelement(i,j,f[i,j]);
                          hopps:=hopps or (f[i,j]=19);
                          if f[i,j]=10 then begin
                             cleansweep; { keine parms wg. Rekursion }
                          end else if hopps then begin
                             for k:=pred(x) to succ(x) do
                             for l:=pred(y) to succ(y) do
                             if (f[k,l] div 10)=2 then
                             if f[k,l]<>29 then showelement(k,l,40);
                          end;
                       end;
                    end;
                 end else if (k<l) then for m:=1 to 3 do begin {Fragezeichen }
                    for i:=pred(x) to succ(x) do for j:=pred(y) to succ(y) do
                    if (f[i,j]>-1) and (f[i,j]<10) then showelement(i,j,30);
                    delay(500);
                    for i:=pred(x) to succ(x) do for j:=pred(y) to succ(y) do
                    if (f[i,j]>-1) and (f[i,j]<10) then showelement(i,j,f[i,j]);
                    delay(500);
                 end;
              end;
         end;
      end else if f[x,y]<30 then begin { Markierung -> ? }
         case key of
           1: begin { ffnen }
                 f[x,y]:=(f[x,y] mod 10) +10;
                 showelement(x,y,f[x,y]);
              end;
           2: begin { mit ? markieren }
                 f[x,y]:=f[x,y]+10;
                 dec(b2);
                 showelement(x,y,f[x,y]);
                 showbombas(b1-b2);
              end;
         end;
      end else begin { Markierung aufheben }
         case key of
           1: begin { ffnen }
                 f[x,y]:=(f[x,y] mod 10) +10;
                 showelement(x,y,f[x,y]);
              end;
         2,3: begin { Markierung weg }
                 f[x,y]:=f[x,y] mod 10;
                 showelement(x,y,f[x,y]);
              end;
         end;
      end;
   end;
end;


function fertig(f:feld):boolean;
var fixund:boolean;
    i,j   :integer;
begin
fixund:=b1=b2;
for i:=1 to xmax do for j:=1 to ymax do
if (f[i,j] mod 10)=9 then fixund:=fixund and (f[i,j]=29);
fertig:=fixund;
end;



procedure ende1;
var c,i,j,k,l,m:integer;
    temp       :string;
begin
   hflag:=true;
   c:=0;
   k:=ofx+dx;
   l:=ofy+dy;
   setcolor(4);
   for i:=200 downto 0 do if not keypressed then begin
      if odd(i) then begin
         inc(c);
         line(k+i,l+i,k+xmax*dx-i-1,l+i);
         line(k+i,l+i,k+i,l+ymax*dy-i-1);
         line(k+xmax*dx-i-1,l+ymax*dy-i-1,k+i,l+ymax*dy-i-1);
         line(k+xmax*dx-i-1,l+ymax*dy-i-1,k+xmax*dx-i-1,l+i);
      end;
   end else exit;
   for m:=1 to 5 do begin
   for i:=1 to 15000 do if not keypressed then begin
      j:=random(xmax*dx);
      k:=random(ymax*dy);
      l:=random(16);
      putpixel(j+ofx+dx,k+ofy+dy,l);
      putpixel(j+ofx+dx+1,k+ofy+dy+1,l);
   end else exit;
   end;
   if hopps then begin
      temp:='* G * A * M * E *   * O * V * E * R * ';
      setcolor(0);
      for i:=-2 to 2 do for j:=-2 to 2 do outtextxy(172+i,236+j,temp);
      setcolor(14); outtextxy(172,236,temp);
   end;
end;


procedure ende2(punkte:longint);
var i,j,k,l,m:integer;  temp:string;
begin
   ende1;
   rectfill(ofx+dx,ofy+dy,ofx+xmax*dx+pred(dx),ofy+3*dx+pred(dy),0);
   rectfill(ofx+dx+1,ofy+dy+1,ofx+xmax*dx+pred(dx)-1,ofy+3*dx+pred(dy)-1,7);
   rectfill(ofx+dx+2,ofy+dy+2,ofx+xmax*dx+pred(dx)-2,ofy+3*dx+pred(dy)-2,4);
   SetTextStyle(triplexfont,horizdir,4);
   Temp:='D';
   setcolor(0);   outtextxy(ofx+3*dx+6,ofy+dy+4,temp);
   setcolor(0);   outtextxy(ofx+3*dx+5,ofy+dy+3,temp);
   setcolor(6);   outtextxy(ofx+3*dx+4,ofy+dy+2,temp);
   setcolor(14);  outtextxy(ofx+3*dx+3,ofy+dy+1,temp);
   SetTextStyle(triplexfont,horizdir,2);
   Temp:='u hast es geschafft, alle Bomben zu entschrfen!';
   setcolor(0);   outtextxy(ofx+5*dx-5,ofy+2*dy-1,temp);
   setcolor(0);   outtextxy(ofx+5*dx-6,ofy+2*dy-2,temp);
   setcolor(6);   outtextxy(ofx+5*dx-7,ofy+2*dy-3,temp);
   setcolor(14);  outtextxy(ofx+5*dx-8,ofy+2*dy-4,temp);
   SetTextStyle(defaultfont,horizdir,1);
   k:=240; j:=28;
   putimage(j,k,bombmask.p_data^,andput); putimage(j-3,k,bomba.p_data^,orput);
   k:=240; j:=452;
   putimage(j,k,bombmask.p_data^,andput); putimage(j-3,k,bomba.p_data^,orput);
   updathighscore(punkte,hscfile,hsc,ofx+13*dx,ofy+9*dy,dy,6,14,0,8);
   hopps:=true;
end;



procedure help;
var i,x1,x2,y1,y2:integer;
    temp         :string;
begin
hflag:=true;
x1:=ofx+dx;
x2:=x1+dx*xmax-1;
y1:=ofy+dy;
y2:=y1+dy*ymax-1;
rectfill(x1,y1,x2,y2,0);
rectfill(x1+1,y1+1,x2-1,y2-1,15);
rectfill(x1+2,y1+2,x2-2,y2-2,7);
x1:=x1+dx;
for i:=1 to 24 do begin
   case i of
   1: temp:='Cabomba La Bomba di Tomba';
   2: temp:='______________________________________________________________________';
   3: temp:='Du mut versuchen, Bomben zu markieren.';
   4: temp:='Wenn Du ein Feld betrittst, so werden Dir die Anzahl der Bomben in den';
   5: temp:='benachbarten Feldern angezeigt. Trittst Du aber auf ein Feld mit einer';
   6: temp:='Bombe, dann KISS YOUR ASS GOODBYE!';
   7: temp:=' ';
   8: temp:='Steuerung:';
   9: temp:='Anwahl des Feldes :  blaue Kachel anklicken mit linker Maustaste';
  10: temp:='Bombe markieren   :  blaue Kachel anklicken mit rechter Maustaste';
  11: temp:='Markierung mit ?  :  Bomben-Markierung mit rechter Maustaste anklicken';
  12: temp:='Markierung lschen:  ?-Markierung mit rechter Maustaste anklicken';
  13: temp:='Wenn man glaubt, alle Bomben in den Nachbarfeldern eines offenen Feldes';
  14: temp:='markiert zu haben, so kann man das Feld anklicken, und alle nicht mar-';
  15: temp:='kierten Felder werden offengelegt. Hat man sich vertan, dann werden';
  16: temp:='Fragezeichen angezeigt, wenn zuwenig Bomben markiert sind, aber stimmt';
  17: temp:='die Zahl, ist darunter eine falsch markierte Bombe, dann tsch!';
  18: temp:=' ';
  19: temp:='Level aussuchen       : Zahl bei [Level:   ] angeben, Taste + oder -';
  20: temp:='Spiel noch mal spielen:        [ Alt ]          Taste A';
  21: temp:='neues Spiel           :        [ Neu ]          Taste N';
  22: temp:='Ende                  :        [Quit ]          Taste <esc>, E oder Q';
  23: temp:=' ';
  24: temp:='           zum Spiel:  <Leertaste> oder ins Feld klicken';
   end;
   setcolor(15); outtextxy(x1,y1+i*dy,temp);
   setcolor( 0); outtextxy(x1-1,y1+i*dy,temp);
end;
end;


procedure holeevent(var key,g,mx,my,keycode1,keycode2:integer);
{ kombinierte Maus-Tastaturabfrage mit Keys }
var k,kx,ky:integer;
    temp:string;   tim:longint;
begin
   showmouse;
   keycode1:=-1;
   keycode2:=-1;
   key:=0;
   g:=0;
   tim:=punkte;
   repeat
      punkte:=updatzeit(ho,mi,se,tic);
      if tim<>punkte then begin
         tim:=punkte;
         str(punkte:4,temp);
         temp:='Zeit:'+temp+' s';
         rectfill(16,448,128,455,1);
         setcolor(2); outtextxy(17,448,temp);
         setcolor(10); outtextxy(16,448,temp);
      end;
      delay(50);
      maustastelos(key,mx,my);
      if key>0 then g:=checkgadget(addr(igad[1]),mx,my);
   until (g>0) or keypressed;

   if keypressed then begin
      keycode1:=ord(readkey);
      if keycode1=0 then keycode2:=ord(readkey);
   end;
   hidemouse;
end;

{ ======================================================================== }

begin
   initscreen(ok);
   if ok then begin
      setcolors;
      getimages;
      intuikram;
      level:=1;
      initgame(level,b1,b2,levelname,hscfile,punkte,f,hopps,ende);
      mainscreen(level,levelname,b1,b2);
      initmouse;
      while not ende do begin
         holeevent(key,g,mx,my,code1,code2);
         punkte:=updatzeit(ho,mi,se,tic);
         if code1>-1 then begin
            case code1 of
                 0: case code2 of
                    59: g:=1;  {f1}
                    end;
                27: g:=4;
                32: mainscreen(level,levelname,b1,b2);
{                49: ende1;
                50: ende2(0);    }
            65, 97: g:=2;      {a}
            69,101: g:=4;      {e}
            72,104: g:=1;      {h}
            ord('+'),ord('-'): begin
               if code1=ord('-') then dec(level) else inc(level);
               initgame(level,b1,b2,levelname,hscfile,punkte,f,hopps,ende);
               mainscreen(level,levelname,b1,b2);
                               end;
            78,110: g:=3;      {n}
            81,113: g:=4;      {q}
            end;
         end;  { keycodes }
         if g>0 then case g of
         1: help;
         2: begin
               resetgame(b2,f);
               mainscreen(level,levelname,b1,b2);
            end;
         3: begin
              initgame(level,b1,b2,levelname,hscfile,punkte,f,hopps,ende);
              mainscreen(level,levelname,b1,b2);
            end;
         4: ende:=true;

         5: begin
              getstring(igad[g]);
              val(sinfo.buff,level,err);
              initgame(level,b1,b2,levelname,hscfile,punkte,f,hopps,ende);
              mainscreen(level,levelname,b1,b2);
            end;
         6: if hflag then begin
               mainscreen(level,levelname,b1,b2);
               hflag:=false;
            end else if not hopps then begin {game}
               x:=(mx-ofx) div dx;
               y:=(my-ofy) div dy;
               if x>xmax then x:=xmax;
               if x<1 then x:=1;
               if y>ymax then y:=ymax;
               if y<1 then y:=1;
               game(x,y,key,b2,f,hopps);
               if hopps then ende1 else if fertig(f) then ende2(punkte);
            end;
         end;
      end;

   end;
   textmode(3);
end.
